#include <Arduino.h>
#include <CAN.h>

#define LED_BUILTIN 2
#define CAN_RX 22
#define CAN_TX 21

int result = 0;

void setup()
{
    pinMode(LED_BUILTIN, OUTPUT);
    digitalWrite(LED_BUILTIN, HIGH);
    CAN.setPins(CAN_RX, CAN_TX);
    Serial.begin(115200);
    while (!Serial)
        ;
    delay(10000);
    Serial.println("CAN Sender");

    // start the CAN bus at 500 kbps
    if (!CAN.begin(500E3))
    {
        Serial.println("Starting CAN failed!");
        while (1)
            ;
    }
}

void loop()
{
    // send packet: id is 11 bits, packet can contain up to 8 bytes of data
    Serial.print("Sending packet ... ");

    result = CAN.beginPacket(0x12);
    if (result)
    {
        CAN.write('h');
        CAN.write('e');
        CAN.write('l');
        CAN.write('l');
        CAN.write('o');
        CAN.endPacket();
        Serial.println("done");
    }
    else
    {
        Serial.println("There was a probelm beginning the packet.");
    }

    delay(1000);

    // send extended packet: id is 29 bits, packet can contain up to 8 bytes of data
    Serial.print("Sending extended packet ... ");

    result = CAN.beginExtendedPacket(0xabcdef);
    if (result)
    {
        CAN.write('h');
        CAN.write('e');
        CAN.write('l');
        CAN.write('l');
        CAN.write('o');
        CAN.endPacket();
        Serial.println("done");
    }
    else
    {
        Serial.println("There was a probelm beginning the extended packet.");
    }

    delay(1000);
}
