/*
Eample of using an interrupt to set global state. which is acted on during the loop.
Place a switch on Pin 4. 
*/
#include <Arduino.h>

#define LED_BUILTIN 2

volatile bool switch_on = false;
volatile u_int switch_counter = 0;

/*
 * Interrupt Callback used to track switch state
 */
void switch_state()
{
    switch_on = !switch_on;
    switch_counter = ++switch_counter;
}

void setup()
{
    pinMode(LED_BUILTIN, OUTPUT);
    pinMode(4, INPUT_PULLUP);
    Serial.begin(115200);
    int interrupt_pin_num = digitalPinToInterrupt(4);
    printf("The interrupt number for pin 4 is: %d", interrupt_pin_num);
    attachInterrupt(interrupt_pin_num, switch_state, FALLING);
}

void loop()
{
    printf("Our counter is at: %d\n", switch_counter);
    if (switch_on)
    {
        digitalWrite(LED_BUILTIN, HIGH);
    }
    else
    {
        digitalWrite(LED_BUILTIN, LOW);
    }
    delay(100);
}